#-------------------------------------------------------------------------------
# Name:        Performance Benchmark of A System
# Purpose:
#
# Author:      Aasish Sharma
#
# Created:     12-02-2023
# Copyright:   (c) aasish.sharma 2023
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import time
import timeit
import random
import numpy as np
from matplotlib import pyplot as plt


def calFact(factRange):
    start_time = timeit.default_timer()
    dt = []
    for i in factRange:
        np.math.factorial(i)
        dt.append(timeit.default_timer()-start_time)
    return dt


def main():
    r = range(1, 151)
    dt1 = []
    dt2 = []
    t1 = time.time()
    dt1 = calFact(r)
    #sleep_time = random.choice(range(1,3))
    #time.sleep(sleep_time)
    t2 = time.time()
    dt2 = calFact(r)

    # Plot
    fig = plt.figure()
    ax  = fig.add_subplot(111)
    ax.plot(r, dt1, label = "Performance at Timestamp A (" + str(t1)[:10] + ")")
    ax.plot(r, dt2, label = "Performance at Timestamp B (" + str(t2)[:10] + ")")
    ax.legend()
    ax.set_xlabel("Factorial")
    ax.set_ylabel("Time")
    ax.set_title("Performance Map")

    fig.savefig("PerformanceMapAt(" + str(time.time())[:8] + ").png", dpi = 300)


if __name__ == '__main__':
    main()
=======
#-------------------------------------------------------------------------------
# Name:        Performance Benchmark of A System
# Purpose:
#
# Author:      Aasish Sharma
#
# Created:     12-02-2023
# Copyright:   (c) aasish.sharma 2023
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import time
import timeit
import numpy as np
from matplotlib import pyplot as plt


def calFact(factRange):
    start_time = timeit.default_timer()
    dt = []
    for i in factRange:
        np.math.factorial(i)
        dt.append(timeit.default_timer()-start_time)
    return dt


def main():
    r = range(1, 151)
    dt1 = []
    dt2 = []
    dt1 = calFact(r)
    dt2 = calFact(r)

    # Plot
    fig = plt.figure()
    ax  = fig.add_subplot(111)
    ax.plot(r, dt1, label = "Performance at Timestamp (" + str(time.time())[:8] + ")")
    ax.plot(r, dt2, label = "Performance at Timestamp (" + str(time.time())[:8] + ")")
    ax.legend()
    ax.set_xlabel("Factorial")
    ax.set_ylabel("Time")
    ax.set_title("Performance Map")

    fig.savefig("PerformanceMapAt(" + str(time.time())[:8] + ").png", dpi = 300)


if __name__ == '__main__':
    main()
=======
#-------------------------------------------------------------------------------
# Name:        Performance Benchmark of A System
# Purpose:
#
# Author:      Aasish Sharma
#
# Created:     12-02-2023
# Copyright:   (c) aasish.sharma 2023
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import time
import timeit
import numpy as np
from matplotlib import pyplot as plt


def calFact(factRange):
    start_time = timeit.default_timer()
    dt = []
    for i in factRange:
        np.math.factorial(i)
        dt.append(timeit.default_timer()-start_time)
    return dt


def main():
    r = range(1, 151)
    dt1 = []
    dt2 = []
    dt1 = calFact(r)
    dt2 = calFact(r)

    # Plot
    fig = plt.figure()
    ax  = fig.add_subplot(111)
    ax.plot(r, dt1, label = "Performance at Timestamp (" + str(time.time())[:8] + ")")
    ax.plot(r, dt2, label = "Performance at Timestamp (" + str(time.time())[:8] + ")")
    ax.legend()
    ax.set_xlabel("Factorial")
    ax.set_ylabel("Time")
    ax.set_title("Performance Map")

    fig.savefig("PerformanceMapAt(" + str(time.time())[:8] + ").png", dpi = 300)


if __name__ == '__main__':
    main()
