#-------------------------------------------------------------------------------
# Name:        Benchmark Tutorial Module1
# Purpose:     HPCSA Benchmark Course
#
# Author:      aasish.sharma
#
# Created:     12-02-2023
# Copyright:   (c) aasish.sharma 2023
# Licence:     CC-BY-SA
#-------------------------------------------------------------------------------

import time
import timeit
import random
import numpy as np

def timer_func(func):

   def function_timer(*args, **kwargs):
        start = time.time()
        value = func(*args, **kwargs)
        end = time.time()
        runtime = end - start
        msg = "{func} took {time} seconds to complete its execution."
        print(msg.format(func = func.__name__,time = runtime))
        return value
   return function_timer



#Empty Function
@timer_func
def fnEmpty():
    return 0


#Looping Function
@timer_func
def fnLoop(count=1000000):
    A = 1
    B = 0
    for x in range(count):
        B = A*x
    return B


#Loop With Delay Function
@timer_func
def fnDelay(count=1):
    for x in range(count):
        sleep_time = random.choice(range(1,3))
        time.sleep(sleep_time)


# Factorial Function
@timer_func
def calFact(factRange):
    start_time = timeit.default_timer()

    dt = []
    for i in factRange:
        np.math.factorial(i)
        dt.append(timeit.default_timer() - start_time)
    return dt


def main():
    fnEmpty()
    fnLoop()
    fnDelay()
    calFact(range(1, 151))


if __name__ == '__main__':
    main()

